
#include <sys/param.h>
#include <sys/reboot.h>
#include <sys/reboot.h>
#include <sys/termios.h>
#include <sys/ttydefaults.h>
//#include <machine/bootinfo.h>

#include <lib/libkern/libkern.h>

#include "stand.h"

#include <sys/param.h>
#include <sys/reboot.h>

#include "loadfile.h"

#include "../u-boot/boot-loader.c"

#define ROUNDED(v, r)	(((v) + (r) - 1) & ~((r) - 1))
#define syncicache(addr, len)   // __syncicache(addr, len)

//struct mvmeppc_bootinfo bootinfo;

static ssize_t
load_ramdisk (const char *fname, char *addr)
{
  ssize_t nr;
  int fd, rval;

  printf ("load_ramdisk fname = '%s'\n", fname);

  /* Open the file. */
  if ((fd = open (fname, 0)) < 0)
  {
    WARN (("open %s", fname ? fname : "<default>"));
    return -1;
  }

  rval = 0;
  while ((nr = read (fd, addr, 1024)) > 0)
  {
    addr += nr;
    rval += nr;
  }

  if (nr == 0)
    printf ("%d=0x%x\n", rval, rval);

  close (fd);
  return nr ? -1 : rval;
}

u_long marks[MARK_MAX];

void *bi_next;
void (*entry) () = 0;;
char *ssym = 0;
char *esym = 0;

char file_name[64];
char rdsk_name[64];
paddr_t avail = 0;

char myconsdev[32];
int mycon = 1;

#define MSR_EE          (1<<15) /* External Interrupt Enable */
int
disable_interrupts (void)
{
  ulong msr;
  asm volatile ("mfmsr %0":"=r" (msr):);

  msr &= ~MSR_EE;
  asm volatile ("mtmsr %0"::"r" (msr));

  return ((msr & MSR_EE) != 0);
}

void
main (bd_t * bd, image_header_t * img, char *cons_dev, char *bootargs)
{
  boot_main (bd, img, cons_dev, bootargs);

  //printf ("call disable_interrupts\n");
  //disable_interrupts ();

  printf ("relocate addr = 0x%x\n", RELOC);

  files_init ();

  file_name[0] = '\0';
  rdsk_name[0] = '\0';

  if (img->ih_type == IH_TYPE_MULTI)
  {
    int i;
    ulong *len_ptr = (ulong *) ((ulong) img + sizeof (image_header_t));
    char *data_ptr = (char *) &len_ptr[1];

    for (i = 0; len_ptr[i]; i += 1)
      data_ptr += sizeof (len_ptr[i]);

    if (len_ptr[0] && len_ptr[1])
    {
      snprintf (file_name, 64, "mem@0x%x,0x%x",
                ROUNDED (len_ptr[0], sizeof (uint32_t)) + data_ptr,
                ROUNDED (len_ptr[1], sizeof (uint32_t)));
      printf ("## image #1 (%s):\n", file_name);
    }

    if (len_ptr[0] && len_ptr[1] && len_ptr[2])
    {
      snprintf (rdsk_name, 64, "mem@0x%x,0x%x",
                ROUNDED (len_ptr[0], sizeof (uint32_t)) +
                ROUNDED (len_ptr[1], sizeof (uint32_t)) + data_ptr,
                ROUNDED (len_ptr[2], sizeof (uint32_t)));
      printf ("## image #2 (%s):\n", rdsk_name);
    }
  }

  memset (marks, 0, sizeof (marks));
  marks[MARK_START] = 0x00000000;

  if (loadfile (file_name, marks, LOAD_KERNEL) < 0)
    panic ("open: %s (%d)\n", strerror (errno), errno);

  printf ("loadfile %s succedded\n", file_name);

  entry = (void *) marks[MARK_ENTRY];
  ssym = (void *) marks[MARK_SYM];
  esym = (void *) marks[MARK_END];
  avail = (paddr_t) esym;

  if (rdsk_name[0])
  {
    void *rdsk_addr = (void *) ROUNDED ((int) esym, 0x1000);
    ssize_t rdsk_size;
    struct btinfo_ram *bi_ram = bi_next;

    printf ("## image #2 (%s):\n", rdsk_name);
    if ((rdsk_size = load_ramdisk (rdsk_name, rdsk_addr)) < 0)
      panic ("open: %s (%d)\n", strerror (errno), errno);

    //bi_ram->start = (unsigned) rdsk_addr;
    //bi_ram->size = rdsk_size;
    //bi_next = bi_add (bi_ram, BTINFO_RAMDISK, sizeof (*bi_ram));

    avail = (paddr_t) rdsk_addr + ROUNDED (rdsk_size, 0x1000);
  }

  //(*entry) (avail, (paddr_t) & bootinfo);
  //printf ("-----------------DUMPING NETBSD CODE START-----------------------\n");
  //print_buffer ("", entry, 64);
  //printf ("-----------------DUMPING NETBSD CODE END-----------------------\n");
  //syncicache (entry, ssym - (char *) entry);
  //(*entry) (bd, img, myconsdev, bootargs);
  printf ("## Transferring control to NetBSD (at address %p) ...\n", entry);
  printf ("## Transferring control to NetBSD (at address %p) ...\n", marks[MARK_SYM]);
  printf ("## Transferring control to NetBSD (at address %p) ...\n", marks[MARK_END]);
  (*entry) (marks[MARK_SYM], marks[MARK_END], bd);

  for (;;);
}
