
#ifdef BOARD_JETWAY
#define UART0_IO_BASE    0xEF600300
#define SERIAL_DEBUG_IO_BASE     UART0_IO_BASE
#define UART_LSR       5        /* In:  Line Status Register */
#define UART_LSR_THRE  0x20     /* Transmit-hold-register empty */
#define readb(addr) in_8((volatile unsigned char *)(addr))
#define writeb(b,addr) out_8((volatile unsigned char *)(addr), (b))

extern inline int
in_8 (volatile unsigned char *addr)
{
  int ret;

  __asm__ __volatile__ ("lbz%U1%X1 %0,%1;\n" "twi 0,%0,0;\n" "isync":"=r" (ret):"m" (*addr));

  return ret;
}

extern inline void
out_8 (volatile unsigned char *addr, int val)
{
  __asm__ __volatile__ ("stb%U0%X0 %1,%0; eieio":"=m" (*addr):"r" (val));
}

static unsigned char *com_port = (unsigned char *) SERIAL_DEBUG_IO_BASE;

/* We assume that the UART has already been initialized by the
   firmware or the boot loader */
static void
serial_putc (unsigned char *com_port, unsigned char c)
{
  if(c == '\n')
    serial_putc(com_port, '\r');
  while ((readb (com_port + (UART_LSR)) & UART_LSR_THRE) == 0);
  writeb (c, com_port);
}

int
puts (const char *s)
{
  char c;

  while ((c = *s++) != '\0')
  {
    serial_putc (com_port, c);
  }
#if 0
  serial_putc (com_port, '\r');
  serial_putc (com_port, '\n');
#endif
}

void
putchar (char c)
{
  serial_putc (com_port, c);
}
#endif
